
# RingBuffer

## Usage

Create a new buffer of the type you need
```c
Ringbuffer_char_s* my_buffer = new_char_buffer();
```
Once the buffer has been created use the generic API to use the buffer
```c
//Write single value
write(my_buffer, 'c');

//Write multiple values
//  -- write(buffer_obj*, data*, num)
write(my_buffer, "hello world", 11);

//Read single value
read(my_buffer);

//Read multiple values
//  -- write(buffer_obj*, dest*, num)
read_n(my_buffer, dest_buf, 11);

//Read entire buf
read_n(my_buffer, dest_buf, -1);
  
//Flush the buffer
flush_buf(my_buffer);

//Delete the buffer
delete_buf(my_buffer);

//Check if buffers full
bool foo = buf_full(my_buffer);

//Check if buffers empty
bool foo = buf_empty(my_buffer);
```

---
## Examples

Coming soon..

---
## Building New Queue Types



---
  ## Testing
  Unit testing is done using the [Ceedling](https://github.com/ThrowTheSwitch/Ceedling) build system. The testing source code is in the **test/** directory and can be run using the Ceedling test command from the top level
  ```bash
  ceedling test:all
  ```

  | **Test function** | **Description** |
  |-|-|
  | test_write_single_byte_to_empty_buffer | Try to write to an empty buffer |
  | test_write_single_byte_to_full_buffer | Try to write to a full buffer |
  | test_read_from_empty_buffer | Try to read from an empty buffer |
  | test_write_the_read | Write a single value then read that value back |
  | test_write_multiple_bytes | Write mulltiple values|
  | test_write_multiple_read_multiple_num | Write multiple value and test how many values are read back |
  | test_write_multiple_read_multiple | Write multiple values and read back those values|
  | test_write_more_than_max_buffer | Try to write more than the buffer can handle |
  | test_cycle_read_write_sequence | Write and read untill buffer is full then verfiy the buffer isent over written |
  | test_flush_buffer | Fill the buffer, try to write and fail. flush the buffer and try to write again|
  | test_read_entire_buffer | Use "-1" to read entire buffer |
  | test_full_flag
  | test_empty_flag
  

### Requirments
+ Ceedling
+ Ruby
+ GCC
---
  ## Documentation
  The source code documentation is autogenerated using the [Doxygen](https://www.doxygen.nl/index.html) documentation generator. To generate the documentation Doxygen tool on the *Doxyfile* from the top level
  ```bash
  doxygen Doyfile
  ```

  This command will populate the **docs/** folder with a LaTeX folder and an HTML folder that will contain the appropriate files. The generated HTML documentation can be found at the following [link](http://blank.org/)